﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

namespace SharpConfig
{
    /// <summary>
    /// Collection of comments.
    /// </summary>
    public class CommentCollection : Collection<Comment>
    {
        internal CommentCollection()
        { }

        internal CommentCollection(IList<Comment> list)
        {
            foreach (var comment in list)
                Add(comment);
        }

        /// <summary>
        /// Converts the type of all comments to a specific type.
        /// </summary>
        ///
        /// <param name="newType">The new comment type.</param>
        public void ConvertType(CommentType newType)
        {
            for (int i = 0; i < Items.Count; i++)
            {
                Comment c = Items[i];
                c.Type = newType;
                Items[i] = c;
            }
        }
    }
}
