﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;
using System.IO;
using SharpConfig;

namespace TestApp
{
    class Program
    {
        static void Main(string[] args)
        {
            Configuration config = Configuration.Load("sample.txt");

            foreach (var category in config.Categories)
            {
                Console.WriteLine(category.Name);
                foreach (var setting in category.Settings)
                {
                    Console.WriteLine(string.Format("\t{0} = {1}",
                        setting.Name,
                        setting.GetValue<string>()));
                }
            }

            Console.Write("\n\n");

            // Read the "BooleanArray" value.
            var booleanArray = config["MiscProperties"]["BooleanArray"].GetValueArray<bool>();

            Console.Write("BooleanArray values:\t");

            foreach (bool b in booleanArray)
                Console.Write(b + " ");

            Console.Write("\n\n");

            // Assignment test
            var videoStruct = new MyVideoStruct();
            videoStruct = config["Video"].AssignTo(videoStruct);
            
            Console.Write(videoStruct.ToString());

            Console.ReadLine();
        }

        struct MyVideoStruct
        {
            public int Width { get; set; }
            public int Height { get; set; }
            public UriFormat Format { get; set; }
            public int aValueThatIsNotSpecifiedInTheFile { get; set; }

            public override string ToString()
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendLine("Width: " + Width);
                sb.AppendLine("Height: " + Height);
                sb.AppendLine("Format: " + Format);
                sb.AppendLine("aValueThatIsNotSpecifiedInTheFile: " + aValueThatIsNotSpecifiedInTheFile);

                return sb.ToString();
            }
        }
    }
}
